var autocomp_box;
var autocomp_timer;
var autocomp_cur_ob;
var autocomp_blur_state;
var autocomp_pos;
var autocomp_count;
var autocomp_selected;
var autocomp_nosubmit;

function autocomp_onsubmit() {
  if(autocomp_nosubmit) {
    autocomp_nosubmit=false;
    return false;
  }
}

function autocomp_clean_box(ob) {
  if(!ob)
    ob=autocomp_cur_ob;

  autocomp_cur_ob=ob;

  if(!autocomp_box) {
    autocomp_box=document.createElement("div");
    autocomp_box.className="autocomp_box";
    autocomp_box.onmousemotion=autocomp_noblur;
    autocomp_box.onmouseover=autocomp_noblur;
    autocomp_box.onmouseout=autocomp_blur;

    ob.form.onsubmit=autocomp_onsubmit;
  }
  else {
    while(x=autocomp_box.firstChild)
      autocomp_box.removeChild(x);
  }

  ob.parentNode.appendChild(autocomp_box);
  p=get_abs_pos(ob);
  autocomp_box.style.position="absolute";
  autocomp_box.style.left=p[0] + "px";
  autocomp_box.style.top =(p[1]+ob.offsetHeight) + "px";
  autocomp_box.style.width=(ob.offsetWidth-1)+"px";
  autocomp_pos=-1;
  autocomp_count=0;
  autocomp_selected=null;
}

function autocomp_choose_text() {
  autocomp_cur_ob.value=this.firstChild.data;
  autocomp_hide_box();
  autocomp_pos=-1;
}

function autocomp_add_text(s) {
  ob1=document.createElement("span");
  autocomp_box.appendChild(ob1);
  ob1.onclick=autocomp_choose_text;
  ob1.className="autocomp_entry";

  text=document.createTextNode(s);
  ob1.appendChild(text);

  br=document.createElement("br");
  autocomp_box.appendChild(br);
}

function autocomp_hide_box() {
  autocomp_pos=-1;
  autocomp_count=0;
  clearTimeout(autocomp_timer);

  if((!autocomp_box)||(!autocomp_box.parentNode))
    return;

  autocomp_box.style.display="none";
  //autocomp_box.parentNode.removeChild(autocomp_box);
  autocomp_box=null;
}

function autocomp_highlight() {
  if(autocomp_selected)
    autocomp_selected.className="autocomp_entry";

  ob=autocomp_box.firstChild;
  while(ob&&(ob.nodeName!="SPAN"))
    ob=ob.nextSibling;

  for(i=0;i<autocomp_pos;i++) {
    ob=ob.nextSibling;
    while(ob&&(ob.nodeName!="SPAN"))
      ob=ob.nextSibling;
  }

  if(ob.offsetTop+ob.offsetHeight-ob.offsetParent.scrollTop+1>ob.offsetParent.clientHeight) {
    ob.offsetParent.scrollTop=ob.offsetTop+ob.offsetHeight+1-ob.offsetParent.clientHeight;
  }
  if(ob.offsetTop-ob.offsetParent.scrollTop<0) {
    ob.offsetParent.scrollTop=ob.offsetTop;
  }

  ob.className="autocomp_selected";
  autocomp_selected=ob;
}

function autocomp_movecursor(ob, event) {
  if(!autocomp_box)
    return;
  if(autocomp_count==0)
    return;

  if(event.keyCode==40) {
    autocomp_pos++;
    if(autocomp_pos>=autocomp_count)
      autocomp_pos=0;

    autocomp_highlight();
    return 1;
  }

  if(event.keyCode==38) {
    autocomp_pos--;
    if(autocomp_pos<0)
      autocomp_pos=autocomp_count-1;

    autocomp_highlight();
    return 1;
  }

}

function autocomp_onkeypress(ob, event) {
  if(!IE)
    if(autocomp_movecursor(ob, event))
      return false;
}

function autocomp_onkeydown(ob, event) {
  if(IE) {
    if(autocomp_movecursor(ob, event))
      return false;
  }
  else {
    if((event.keyCode==38)||(event.keyCode==40))
      return;
  }

  if((autocomp_box)&&(event.keyCode==13)) {
    autocomp_cur_ob.value=autocomp_selected.firstChild.data;
    autocomp_hide_box();
    autocomp_nosubmit=true;
  }

  autocomp_hide_box();
  return 1;
}

function autocomp_get_data(data) {
  autocomp_clean_box();
  autocomp_count=data.getElementsByTagName('ac').length;
  if(autocomp_count==0) {
    msg=ob.getAttribute("autocomp_error");
    autocomp_add_text(msg);
  }
  else {
    for(i=0;i<autocomp_count;i++) {
      autocomp_add_text(data.getElementsByTagName('ac')[i].firstChild.nodeValue);
    }
  }
}

function autocomp_search() {
  ob=autocomp_cur_ob;

  if(ob.value!="") {
    autocomp_clean_box(ob);
    search_msg=ob.getAttribute("autocomp_search_msg");
    autocomp_add_text(search_msg);

    url=ob.getAttribute("autocomp_url");
    url=url.replace(/%value%/, ob.value);
    start_xmlreq(url, autocomp_get_data);
  }

  return 1;
}

function autocomp_onkeyup(ob, event) {
  if(!ob)
    ob=autocomp_cur_ob;

  autocomp_cur_ob=ob;

  if((event.keyCode==38)||(event.keyCode==40)||
     (event.keyCode==13)||(event.keyCode==27))
    return false;

  clearTimeout(autocomp_timer);
  autocomp_timer=setTimeout("autocomp_search()", 500);
}

function autocomp_onblur(ob, event) {
  if(autocomp_blur_state)
    autocomp_hide_box();

/*  p=get_abs_pos(autocomp_box);
  alert(event+" "+event.pageX+" "+p[0]+" "+autocomp_box.offsetWidth);
  if((event.clientX>=p[0])&&(event.clientX<p[0]+autocomp_box.offsetWidth)&&
     (event.clientY>=p[1])&&(event.clientY<p[1]+autocomp_box.offsetHeight)) {
    alert("x");
  }*/

}

function autocomp_blurred() {
}

function autocomp_noblur() {
  autocomp_blur_state=0;
}

function autocomp_blur() {
  autocomp_blur_state=1;
}
